/**
 *
 */
package lazyj.page.tags;

import lazyj.Format;
import lazyj.page.StringFormat;

/**
 * <i>json</i> tag produces a JSON encoding of the value.
 *
 * @author costing
 * @since 2022-03-01
 * @see Enc
 * @see Esc
 */
public final class JSON implements StringFormat {

	/**
	 * Make a string usable in a JS script, as a string value. Use this when you are about to initialize a string
	 * in a JS with a value that might contain special characters.
	 *
	 * @param sTag
	 *            tag name, ignored
	 * @param sOption
	 *            always "json"
	 * @param s
	 *            value to transform
	 * @return JSON encoding of the string
	 * @see Format#escJSON(String)
	 */
	@Override
	public String format(final String sTag, final String sOption, final String s) {
		return Format.escJSON(s);
	}

}
